package asm_test

import (
	"testing"

	"git.akyoto.dev/cli/q/src/asm"
	"git.akyoto.dev/cli/q/src/linux"
	"git.akyoto.dev/cli/q/src/register"
	"git.akyoto.dev/go/assert"
)

func TestHello(t *testing.T) {
	a := asm.New()

	hello := []byte("Hello\n")
	a.MoveRegisterNumber(register.Syscall0, linux.Write)
	a.MoveRegisterNumber(register.Syscall1, 1)
	a.MoveRegisterData(register.Syscall2, hello)
	a.MoveRegisterNumber(register.Syscall3, uint64(len(hello)))
	a.Syscall()

	a.MoveRegisterNumber(register.Syscall0, linux.Exit)
	a.MoveRegisterNumber(register.Syscall1, 0)
	a.Syscall()

	code, data := a.Finalize()

	assert.DeepEqual(t, code, []byte{
		0xb8, 0x01, 0x00, 0x00, 0x00,
		0xbf, 0x01, 0x00, 0x00, 0x00,
		0xbe, 0xa2, 0x00, 0x40, 0x00,
		0xba, 0x06, 0x00, 0x00, 0x00,
		0x0f, 0x05,

		0xb8, 0x3c, 0x00, 0x00, 0x00,
		0xbf, 0x00, 0x00, 0x00, 0x00,
		0x0f, 0x05,
	})

	assert.DeepEqual(t, data, hello)
}
